
//motor 1 - nastavení pinů 
#define pinEnableDef 13 
#define pinStepDef    4
#define pinDirDef     3

#define mode0Motor1Def 30
#define mode1Motor1Def 31
#define mode2Motor1Def 32

//motor 2 - nastavení pinů
#define pinEnable2Def 12 
#define pinStep2Def    6
#define pinDir2Def     5

#define mode0Motor2Def 40
#define mode1Motor2Def 41
#define mode2Motor2Def 42

// pozice zkumavky 0,0 na platičku 1
#define plato1x0  0;
#define plato1y0  0;
// pozice zkumavky 0,0 na platičku 2
#define plato2x0  100;
#define plato2y0  0;
// pozice zkumavky 0,0 na platičku 3
#define plato3x0  200;
#define plato3y0  0;
    
#define vz 8.99//konstanta vzdálenosti dvou zkumavek
#define stepToMM 160 //konstanta kroku potřebních na mm

float xakt;
float yakt;


class Motor
{
    private:
          byte _pinEnable;
          byte _pinStep;
          byte _pinDir;
          byte _mode0;
          byte _mode1;
          byte _mode2;

    public:
          Motor(byte pinEnable, byte pinStep, byte pinDir, byte mode0, byte mode1, byte mode2);
          void setOnMotor();
          void setOffMotor();

          byte getStepPin();
          byte getDirPin();
        
          void setStepSize(bool a1, bool a2, bool a3);
        
};

Motor::Motor(byte pinEnable, byte pinStep, byte pinDir, byte mode0, byte mode1, byte mode2) : _pinEnable(pinEnable), _pinStep(pinStep), _pinDir(pinDir), _mode0(mode0), _mode1(mode1), _mode2(mode2)
{
  pinMode( _pinEnable, OUTPUT );
  pinMode( _pinDir   , OUTPUT );
  pinMode( _pinStep  , OUTPUT );

  pinMode( _mode0  , OUTPUT );
  pinMode( _mode1  , OUTPUT );
  pinMode( _mode2  , OUTPUT );
  this->setStepSize(false,false,false);
}

void Motor::setOnMotor()
{
    digitalWrite(_pinEnable, LOW);
}

void Motor::setOffMotor()
{
    digitalWrite(_pinEnable, HIGH);
}

byte Motor::getStepPin()
{
    return _pinStep;  
}

byte Motor::getDirPin()
{
    return _pinDir;
}

void Motor::setStepSize(bool a1, bool a2, bool a3)
{
    digitalWrite(_mode0, a1);
    digitalWrite(_mode1, a2);
    digitalWrite(_mode2, a3);
}

Motor motor1(pinEnableDef, pinStepDef, pinDirDef, mode0Motor1Def, mode1Motor1Def, mode2Motor1Def);
Motor motor2(pinEnable2Def, pinStep2Def, pinDir2Def, mode0Motor2Def, mode1Motor2Def, mode2Motor2Def); 



void step(Motor m1, boolean dir0, float steps0,
          Motor m2, boolean dir1, float steps1) 
          {
    // nastavení směru
    digitalWrite(m1.getDirPin(), dir0);
    digitalWrite(m2.getDirPin(), dir1);
    // přepočet mm na kroky
    steps0 = steps0 * stepToMM;
    steps1 = steps1 * stepToMM;
    // Ovládaní motoru + zachytávání hodnot endStopu
    long max_steps = max(steps0, steps1);
    Serial.println(max_steps);
    m1.setOnMotor();
    m2.setOnMotor();
    int endStopX = digitalRead(7);
    int endStopY = digitalRead(8);
    for (long i = 0; i < max_steps; i++) {
        endStopX = digitalRead(7);
        endStopY = digitalRead(8);
      
        //X
        if (i < steps0) {
          
          if ((endStopX == 0) || (dir0 == 1))
            digitalWrite(m1.getStepPin(), HIGH); 
          else {
            m1.setOffMotor();
            xakt=0;
          }
        }else
        m1.setOffMotor();
        //Y
        
        if (i < steps1) {
          //endStop neseplý or směr od něj 
          if ((endStopY == 0) || (dir1 == 0))
            digitalWrite(m2.getStepPin(), HIGH); 
          else {
            m2.setOffMotor();
            yakt=0;
          }
        }else
        m2.setOffMotor();
        
        delayMicroseconds(80);
        if (i < steps0)   digitalWrite(m1.getStepPin(), LOW);
        if (i < steps1)  digitalWrite(m2.getStepPin(), LOW);
        
    }
    m1.setOffMotor();
    m2.setOffMotor();
}

void pohyb(int plato ,int xz,int yz){
  float x;
  float y;
  float x0;
  float y0;
  switch (plato) {
    case 1:
      x0= plato1x0;
      y0= plato1y0;
      break;
    case 2:
      x0= plato2x0;
      y0= plato2y0;
      break;
      case 3:
      x0= plato3x0;
      y0= plato3y0;
      break;
    default: 
      // if nothing else matches, do the default
      // default is optional
    break;
  }
  Serial.print(xz);
  Serial.print(" , ");
  Serial.println(yz);
  x =  (x0 + (xz * vz))- xakt; 
  y =  (y0 + (yz * vz)) - yakt;
  
  xakt=xakt+x;
  yakt=yakt+y;
  
  Serial.print("x=");
  Serial.println(x);
  Serial.print("y=");
  Serial.println(y);
  // + +
  if ((x >= 0)  && (y >= 0)) {
    Serial.println("+,+");
    step(motor1, true, x, motor2, false,y);
  }
  // + -
  if ((x >= 0)  && (y < 0)) {
    y = abs(y);
    step(motor1, true, x, motor2, true, y);
  }
  // - +
  if ((x < 0)  && (y >= 0)) {
    x = abs(x);
    step(motor1, false, x, motor2, false, y);
  }
  // - -
  if ((x < 0)  && (y < 0)) {
     x = abs(x);
     y = abs(y);     
    step(motor1, false, x, motor2, true, y);
  } 
}


long plato ; 
long x ; 
long y ; 
  
void setup(){
  Serial.begin(9600);
   pinMode(7, INPUT);
   xakt = 0;
   yakt = 0;
   motor1.setStepSize(true,true,true);
   motor2.setStepSize(true,true,true);  
   motor1.setOffMotor();
   motor2.setOffMotor();
 
}

void loop(){
  int i = 0;
 
if (Serial.available() > 0) {
                // read the incoming byte:
                plato = Serial.parseInt();
                x = Serial.parseInt();
                y = Serial.parseInt();
                pohyb(plato,x,y);
                
        }
}

